effect give @a saturation 10 0 true
effect give @a night_vision 12 0 true
execute as @a at @s if block ~ ~-0.1 ~ minecraft:green_terracotta run scoreboard players set @s jump_boost 5
execute as @a at @s if block ~ ~-0.1 ~ minecraft:green_wool run scoreboard players set @s jump_boost_two 5
execute as @a[scores={sneak=1..}] at @s if block ~0.7 ~0.1 ~ minecraft:pink_terracotta run scoreboard players set @s climbing 4
execute as @a[scores={sneak=1..}] at @s if block ~-0.7 ~0.1 ~ minecraft:pink_terracotta run scoreboard players set @s climbing 4
execute as @a[scores={sneak=1..}] at @s if block ~ ~0.1 ~0.7 minecraft:pink_terracotta run scoreboard players set @s climbing 4
execute as @a[scores={sneak=1..}] at @s if block ~ ~0.1 ~-0.7 minecraft:pink_terracotta run scoreboard players set @s climbing 4
scoreboard players remove @a[scores={jump_boost=1..}] jump_boost 1
scoreboard players remove @a[scores={jump_boost_two=1..}] jump_boost_two 1
scoreboard players remove @a[scores={climbing=1..}] climbing 1
effect give @a[scores={jump_boost=1..}] jump_boost 1 4 false
effect give @a[scores={jump_boost_two=1..}] jump_boost 1 0 false
effect give @a[scores={climbing=2..}] levitation 1 3 true
effect clear @a[scores={jump_boost=0,jump_boost_two=0}] jump_boost
effect clear @a[scores={climbing=1}] levitation
execute as @a[scores={climbing=1..}] at @s run particle block pink_terracotta ~ ~ ~

item replace entity @a[tag=hasShrinker] hotbar.0 with minecraft:carrot_on_a_stick{CustomModelData:1,display:{Lore:['{"text":"Hold and sneak to shrink and grow","color":"gray","italic":"false"}','{"text":"Double right click to tp to the last checkpoint","color":"gray","italic":"false"}','{"text":"Drop twice to return to lobby","color":"gray","italic":"false"}','{"text":"Look up and single right click to view important","color":"gray","italic":"false"}','{"text":" unlooted containers and secrets info","color":"gray","italic":"false"}']}}
item replace entity @a[tag=hasShrinker,scores={shrinkerColor=1}] hotbar.0 with minecraft:carrot_on_a_stick{CustomModelData:2,display:{Lore:['{"text":"How are you reading this?","color":"gray","italic":"false"}',]}}
item replace entity @a[tag=hasShrinker,scores={shrinkerColor=2..}] hotbar.0 with minecraft:carrot_on_a_stick{CustomModelData:3,display:{Lore:['{"text":"What are you doing?","color":"gray","italic":"false"}',]}}
scoreboard players set @a[scores={shrinkerColor=2}] shrinkerColor 0
scoreboard players remove @a[scores={shrinkerColor=3..}] shrinkerColor 1

execute as @a at @s if block ~ ~-0.1 ~ slime_block run particle minecraft:splash ~ ~ ~ 0.5 0.2 0.5 1 100
execute as @a at @s if block ~ ~-0.1 ~ slime_block run playsound minecraft:block.honey_block.step ambient @a ~ ~-1 ~ 5 1.5
execute as @a at @s if block ~ ~-0.1 ~ slime_block run playsound minecraft:block.slime_block.break ambient @a ~ ~-1 ~ 5 0
execute as @a at @s if block ~ ~-0.1 ~ slime_block run effect give @s minecraft:levitation 2 11 false

execute as @e at @s if block ~ ~-0.1 ~ orange_stained_glass_pane[east=false,west=false] run tp @s ~ ~ ~0.008
execute as @e at @s if block ~ ~-0.1 ~ magenta_stained_glass_pane[east=false,west=false] run tp @s ~ ~ ~-0.008
execute as @e at @s if block ~ ~-0.1 ~ orange_stained_glass_pane[north=false,south=false] run tp @s ~-0.008 ~ ~
execute as @e at @s if block ~ ~-0.1 ~ magenta_stained_glass_pane[north=false,south=false] run tp @s ~0.008 ~ ~
execute as @e at @s if block ~ ~-0.1 ~0.3 jungle_log[axis=z] run tp @s ~ ~ ~-0.125
execute as @e at @s if block ~ ~-0.1 ~-0.3 birch_log[axis=z] run tp @s ~ ~ ~0.125
execute as @e at @s if block ~-0.3 ~-0.1 ~ jungle_log[axis=x] run tp @s ~0.125 ~ ~
execute as @e at @s if block ~0.3 ~-0.1 ~ birch_log[axis=x] run tp @s ~-0.125 ~ ~

tag @a remove slot0
tag @a[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick"},SelectedItemSlot:0}] add slot0
item replace entity @a[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick"}},tag=!slot0] weapon.mainhand with air
item replace entity @a[nbt={Inventory:[{Slot:-106b,id:"minecraft:carrot_on_a_stick"}]}] weapon.offhand with air
execute unless entity @a[scores={shrinkTimer=-9999..9999}] run scoreboard players set @a shrinkTimer 0
scoreboard players add @a[scores={shrinkTimer=55..}] shrinkTimer 1
scoreboard players add @a[scores={sneak=1..,shrinkTimer=..54},tag=slot0] shrinkTimer 1

execute if entity @a[scores={shrinkTimer=1..}] run function sp:space/shrinktimer
scoreboard players set @a[scores={shrinkTimer=..15,shrinkerColor=1}] shrinkerColor 0

execute as @a[scores={shrinkTimer=60}] positioned 127 246 127 at @s[distance=..21] run function sp:shrink
execute as @a[scores={shrinkTimer=60}] positioned 127 246 127 at @s[distance=21..] run function sp:grow

scoreboard players add @a[scores={blackVision=1..}] blackVision 1
execute at @a[scores={blackVision=1..}] run particle minecraft:entity_effect ~ ~0.5 ~ 0.2 0.5 0.2 1 5
clear @a[scores={blackVision=20..}] carved_pumpkin
scoreboard players set @a[scores={blackVision=20..}] blackVision 0

scoreboard players set @a[scores={shrinkTimer=60..}] shrinkTimer -20

scoreboard players set @a[scores={shrinkTimer=15..54},tag=!slot0] sneak 0
execute at @a[scores={shrinkTimer=15..54,sneak=0}] run stopsound @a[distance=..5] ambient
execute at @a[scores={shrinkTimer=15..54,sneak=0}] run playsound minecraft:entity.blaze.hurt ambient @p ~ ~ ~ 0.5 1
execute at @a[scores={shrinkTimer=15..54,sneak=0}] run effect clear @p nausea
execute at @a[scores={shrinkTimer=15..54,sneak=0}] run effect clear @p slowness
execute at @a[scores={shrinkTimer=15..54,sneak=0}] run effect clear @p speed
scoreboard players set @a[scores={sneak=0,shrinkTimer=..54}] shrinkTimer 0

#Slimes
scoreboard players add @e[type=armor_stand,tag=smallwslimedispenser] secondTimer 1
scoreboard players set @e[type=armor_stand,tag=smallwslimedispenser,scores={secondTimer=101..}] secondTimer 0
execute as @e[type=armor_stand,tag=smallwslimedispenser,scores={secondTimer=100},y_rotation=0] at @s if entity @p[distance=..10] run summon slime ^ ^ ^0.8 {Invulnerable:1,Size:0,NoAI:1,NoGravity:0,Tags:["smallbeltslime","beltslime"],PersistenceRequired:1b,Rotation:[0f,0f]}
execute as @e[type=armor_stand,tag=smallwslimedispenser,scores={secondTimer=100},y_rotation=0] positioned 127 246 127 if entity @a[distance=21..] at @s run summon slime ^ ^-16 ^0.8 {Invulnerable:1,Size:15,NoAI:1,NoGravity:0,Tags:["bigbeltslime","beltslime"],PersistenceRequired:1b,Rotation:[0f,0f]}
execute as @e[type=armor_stand,tag=smallwslimedispenser,scores={secondTimer=100},y_rotation=90] at @s if entity @p[distance=..10] run summon slime ^ ^ ^0.8 {Invulnerable:1,Size:0,NoAI:1,NoGravity:0,Tags:["smallbeltslime","beltslime"],PersistenceRequired:1b,Rotation:[90f,0f]}
execute as @e[type=armor_stand,tag=smallwslimedispenser,scores={secondTimer=100},y_rotation=90] positioned 127 246 127 if entity @a[distance=21..] at @s run summon slime ^ ^-16 ^0.8 {Invulnerable:1,Size:15,NoAI:1,NoGravity:0,Tags:["bigbeltslime","beltslime"],PersistenceRequired:1b,Rotation:[90f,0f]}
execute as @e[type=armor_stand,tag=smallwslimedispenser,scores={secondTimer=100},y_rotation=-180] at @s if entity @p[distance=..10] run summon slime ^ ^ ^0.8 {Invulnerable:1,Size:0,NoAI:1,NoGravity:0,Tags:["smallbeltslime","beltslime"],PersistenceRequired:1b,Rotation:[180f,0f]}
execute as @e[type=armor_stand,tag=smallwslimedispenser,scores={secondTimer=100},y_rotation=-180] positioned 127 246 127 if entity @a[distance=21..] at @s run summon slime ^ ^-16 ^0.8 {Invulnerable:1,Size:15,NoAI:1,NoGravity:0,Tags:["bigbeltslime","beltslime"],PersistenceRequired:1b,Rotation:[180f,0f]}
execute as @e[type=armor_stand,tag=smallwslimedispenser,scores={secondTimer=100},y_rotation=-90] at @s if entity @p[distance=..10] run summon slime ^ ^ ^0.8 {Invulnerable:1,Size:0,NoAI:1,NoGravity:0,Tags:["smallbeltslime","beltslime"],PersistenceRequired:1b,Rotation:[-90f,0f]}
execute as @e[type=armor_stand,tag=smallwslimedispenser,scores={secondTimer=100},y_rotation=-90] positioned 127 246 127 if entity @a[distance=21..] at @s run summon slime ^ ^-16 ^0.8 {Invulnerable:1,Size:15,NoAI:1,NoGravity:0,Tags:["bigbeltslime","beltslime"],PersistenceRequired:1b,Rotation:[-90f,0f]}

scoreboard players add @a[tag=!nofx] soundTimer 1
scoreboard players set @e[tag=!nofx,scores={soundTimer=201..}] soundTimer 0

execute at @a[tag=!nofx,scores={soundTimer=200},limit=1] if predicate sp:m_chance/10pc run playsound minecraft:sfx.random weather @a ~ ~ ~ 0.6 1 0.6

execute as @e[type=slime,tag=bigbeltslime,tag=!located] run function sp:bigbeltslimelocation
scoreboard players add @e[type=slime,tag=beltslime] secondTimer 1
execute as @e[type=slime,tag=beltslime,scores={secondTimer=500..510}] at @s run tag @s add eliminate
execute as @e[type=slime,tag=bigbeltslime] at @s store result score @s sneak run execute if entity @e[type=slime,distance=..5]
execute as @e[type=slime,tag=bigbeltslime,scores={sneak=2..}] at @s run tag @s add eliminate

execute as @e[type=slime,tag=beltslime] at @s if block ~ ~-0.5 ~ air run tag @s add eliminate
execute as @e[type=slime,tag=bigbeltslime] at @s if block ~ ~-1 ~ slime_block run tag @s add eliminate
execute as @e[type=slime,tag=smallbeltslime] at @s if block ~ ~-0.1 ~ cauldron run tag @s add eliminate
execute as @e[type=slime,tag=bigbeltslime] at @s if block ~ ~-1 ~ polished_diorite run tp @s ^ ^ ^0.125
execute as @e[type=slime,tag=smallbeltslime] at @s if block ~ ~-0.1 ~ cauldron run tp @s ^ ^ ^0.008
execute as @e[type=armor_stand,tag=smallwslimedispenser] at @s unless block ~ ~ ~ orange_glazed_terracotta run kill @s
execute as @e[type=slime] at @s positioned ~ -900 ~ as @s[distance=..500] run data merge entity @s {Size:0,Health:0}

#Eliminate Slimes
tp @e[type=slime,tag=eliminate] 156 241 140
execute as @e[type=slime,tag=eliminate] at @s run data merge entity @s {Size:0,Health:0,Silent:1}

#Checkpoint
execute as @a at @s if block ~ ~-0.05 ~ #sp:checkpoint run function sp:space/setcp

#Red Slime
execute as @a[gamemode=!creative] at @s if block ~ ~0.9 ~ red_carpet run kill @s
execute as @a[gamemode=!creative] at @s if block ~ ~-0.1 ~ red_terracotta run kill @s
execute as @a[gamemode=!creative] at @s if block ~0.2 ~-0.1 ~ red_terracotta run kill @s
execute as @a[gamemode=!creative] at @s if block ~-0.2 ~-0.1 ~ red_terracotta run kill @s
execute as @a[gamemode=!creative] at @s if block ~ ~-0.1 ~0.2 red_terracotta run kill @s
execute as @a[gamemode=!creative] at @s if block ~ ~-0.1 ~-0.2 red_terracotta run kill @s

#Shrinker gadget
execute as @e[tag=chestmarker] at @s if data block ~ ~0.5 ~ {Items:[]} run kill @s
execute as @a[scores={click=1..},x_rotation=-90..-80] run function sp:space/sgtracker
execute as @a[scores={secondTimer=1..,click=1..}] at @s run function sp:tptocheckpoint
tag @e[type=item,nbt={Item:{id:"minecraft:carrot_on_a_stick"}}] add sg
execute as @a[scores={secondTimer=21..30}] at @s if entity @e[type=item,sort=nearest,limit=1,tag=sg] run function sp:hub
execute as @a at @s if entity @e[type=item,sort=nearest,limit=1,tag=sg] run scoreboard players set @p[scores={secondTimer=..19}] secondTimer 30
kill @e[tag=sg]
execute unless entity @a[scores={secondTimer=-9999..9999}] run scoreboard players set @a secondTimer 0
scoreboard players set @a[scores={click=1..,secondTimer=0}] secondTimer 10
scoreboard players remove @a[scores={secondTimer=1..}] secondTimer 1
scoreboard players set @a[scores={secondTimer=20}] secondTimer 0
scoreboard players set @a[scores={click=1..}] click 0

#Block changing
execute as @a run scoreboard players operation @s hasGrassB = @s hasGrass
execute as @a store result score @s hasGrass run clear @s minecraft:dandelion 0
execute as @a if score @s hasGrass > @s hasGrassB run function sp:updateblockspre
execute as @a run scoreboard players operation @s hasPinkB = @s hasPink
execute as @a store result score @s hasPink run clear @s minecraft:poppy 0
execute as @a if score @s hasPink > @s hasPinkB run function sp:updateblockspre
execute if entity @a[scores={fillPot=1..}] run function sp:updateblockspre
execute if entity @a[scores={emptyCauldron=1..}] run function sp:updateblockspre
execute if entity @a[scores={fillCauldron=1..}] run function sp:updateblockspre

#Voice timers
execute if entity @a[nbt={Inventory:[{id:"minecraft:gold_ingot"}]}] run advancement grant @a only sp:root
tag @a[scores={TimerIntro=1}] add hasShrinker
clear @a[tag=hasShrinker] gold_ingot
scoreboard players add @a[scores={TimerIntro=1..}] TimerIntro 1
execute as @a[scores={TimerIntro=1..}] run stopsound @a weather
execute as @a[scores={TimerIntro=20}] at @s run playsound minecraft:voice.intro voice @s ~ ~ ~ 5
tellraw @a[scores={TimerIntro=95}] {"text":"New specimen detected. Transferring to initiation protocol.\n","color":"green"}
tellraw @a[scores={TimerIntro=240}] {"text":"Thank you for using Shrink Lab technologies developed by Shrink Labs Co. Before we begin, a calibration is needed. Please stand by.\n","color":"green"}
tellraw @a[scores={TimerIntro=490}] {"text":"Calibration complete. Shrinking capabilities are now authorized. This device is your shrinker gadget, which is able to perform a number of functions. Let’s try activating the primary shrinking function. To do so, firmly hold the gadget in your hand and sneak until resizing takes effect. Give it a try.\n","color":"green"}
effect give @a[scores={TimerIntro=410}] minecraft:poison 4 0 true
effect give @a[scores={TimerIntro=410}] minecraft:slowness 4 0 true
effect give @a[scores={TimerIntro=410}] minecraft:hunger 4 0 true
scoreboard players set @a[scores={TimerIntro=1..,shrinkTimer=1..}] shrinkTimer 0
scoreboard players set @a[scores={TimerIntro=800..}] TimerIntro 0

scoreboard players add @a[scores={TimerSLocation=1..}] TimerSLocation 1
execute as @a[scores={TimerSLocation=1..}] run stopsound @a weather
execute as @a[scores={TimerSLocation=5}] at @s run playsound minecraft:voice.slocation voice @s ~ ~ ~ 5
tellraw @a[scores={TimerSLocation=5}] {"text":"Due to safety limitations, the shrinker gadget will only execute if the user is in a clear enough area.\n","color":"green"}
tellraw @a[scores={TimerSLocation=125}] {"text":"The empty side of that nearby table is an adequate example of a clear enough area.\n","color":"green"}
execute as @a[scores={TimerSLocation=145}] run particle minecraft:firework 113 243.3 119 0.2 0.1 0.2 0.01 20
scoreboard players set @a[scores={TimerSLocation=200..}] TimerSLocation 0

scoreboard players add @a[scores={TimerFinish=1..}] TimerFinish 1
execute as @a[scores={TimerFinish=1..}] run stopsound @a weather
execute as @a[scores={TimerFinish=30}] at @s run title @a subtitle [{"text":"The Factory ","color":"gold"},{"text":"by BrosephMC","color":"gray","italic":"true"}]
execute as @a[scores={TimerFinish=30}] at @s run title @a title {"text":"Shrink Parkour 3","color":"blue","bold":"true"}
execute as @a[scores={TimerFinish=70}] at @s run playsound minecraft:ui.toast.challenge_complete ambient @a ~ ~ ~ 5
tellraw @a[scores={TimerFinish=180}] {"text":"Thank you for visiting and exploring Shrink Labs Co. We hope your time spent using Shrink Lab technologies was enjoyable. If you have any comments about the experience, please feel free to contact our CEO, BrosephMC, on any media through which this experience was published.\n","color":"dark_green"}
execute as @a[scores={TimerFinish=140}] at @s run clear @a carved_pumpkin
execute at @a[scores={TimerFinish=140}] run particle minecraft:entity_effect ~ ~1 ~ 0.2 0.5 0.2 1 20
scoreboard players set @a[scores={TimerFinish=200..}] TimerFinish 0

#Special Advancement Triggers
execute as @a[advancements={sp:green_block=false}] at @s if block ~ ~-0.1 ~ green_terracotta run advancement grant @s only sp:green_block

#Keypad colors
execute at @e[tag=keypad,tag=red] run particle minecraft:dust 1 0.1 0.1 0.4 ~ ~0.2 ~ 0.1 0 0.1 0.1 1
execute at @e[tag=keypad,tag=orange] run particle minecraft:dust 1 0.5 0.1 0.4 ~ ~0.2 ~ 0.1 0 0.1 0.1 1
execute at @e[tag=keypad,tag=yellow] run particle minecraft:dust 1 1 0.1 0.4 ~ ~0.2 ~ 0.1 0 0.1 0.1 1
execute at @e[tag=keypad,tag=green] run particle minecraft:dust 0.1 1 0.1 0.4 ~ ~0.2 ~ 0.1 0 0.1 0.1 1
execute at @e[tag=keypad,tag=blue] run particle minecraft:dust 0.1 0.6 1 0.4 ~ ~0.2 ~ 0.1 0 0.1 0.1 1
execute at @e[tag=keypad,tag=pink] run particle minecraft:dust 1 0.1 1 0.4 ~ ~0.2 ~ 0.1 0 0.1 0.1 1

#Secrets
execute as @e[tag=Secret] at @s run particle minecraft:firework ~ ~0.4 ~ 0.2 0.2 0.2 0.01 1 force
execute as @e[tag=SuperSecret] at @s run particle minecraft:angry_villager ~ ~-0.1 ~ 0.2 0.2 0.2 0.01 1 normal
execute as @a at @s if entity @e[type=armor_stand,tag=Secret,distance=..1] run playsound minecraft:entity.player.levelup ambient @a ~ ~ ~ 5 1
execute as @a at @s if entity @e[type=armor_stand,tag=Secret,distance=..1] run scoreboard players add Secrets Collected 1
execute as @a at @s as @e[type=armor_stand,tag=Secret,distance=..1] run kill @s
execute as @a at @s if entity @e[type=armor_stand,tag=SuperSecret,distance=..1] run playsound minecraft:entity.player.levelup ambient @a ~ ~ ~ 5 0
execute as @a at @s if entity @e[type=armor_stand,tag=SuperSecret,distance=..1] run scoreboard players add SuperSecrets Collected 1
execute as @a at @s as @e[type=armor_stand,tag=SuperSecret,distance=..1] run kill @s

execute if score Secrets Collected >= 30 int run advancement grant @a only sp:secrets_2
execute if score SuperSecrets Collected >= 12 int run advancement grant @a only sp:secrets_3

execute positioned 176 67 19 run title @a[distance=..2] actionbar ["Hint: Sneak!"]
execute positioned 176 75 28 run title @a[distance=..2] actionbar ["Hint: Sneak!"]

#Music


scoreboard players set @a[scores={sneak=1..}] sneak 0

execute as @e[type=item_frame,tag=keypad] at @s unless block ~ ~ ~ jungle_wall_sign run kill @s
execute as @e[type=armor_stand,tag=shrinkerStand] at @s if block ~ ~1 ~ air run kill @s

execute as @a[advancements={sp:bucket=false}] if data entity @s {Inventory:[{id:"minecraft:bucket"}]} run advancement grant @s only sp:bucket